2 '********************************************************************
3 '*****  CALCULATE VOLTS PEAK TO PEAK VS DBM                     *****
4 '*****  WRITTEN BY: PETER EHLIG                                 *****
5 '*****  COPYRIGHT TEXAS INSTRUMENTS,  07/25/86                  *****
6 '********************************************************************
10 DIM X(100),P(100),VRMS(100),VP(100),VPP(100)
20 OPEN "LPT1:" FOR OUTPUT AS #3
30 PRINT#3," "
40 PRINT#3," "
50 PRINT#3," "
60 PRINT#3," "
70 PRINT#3," "
80 PRINT#3," "
90 PRINT#3," "
100 PRINT#3," "
110 C1 = LOG(10)
120 C2 = SQR(2)
130 FOR I = 0 TO 65
140 X(I) = - I
150 P(I) = EXP(X(I) * C1 / 10)
160 VRMS(I) = SQR(P(I) * .6)
170 VP(I) = VRMS(I) * C2
180 VPP(I) = VP(I) * 2
190 ' PRINT USING "##    ";I;
200 ' PRINT USING "#.#######   ";VRMS(I),VP(I),VPP(I)
210 NEXT
220 PRINT#3, "                                   APPENDIX F"
230 PRINT#3," "
240 PRINT#3, "                         SIGNAL LEVEL   dBm vs. VOLTAGE"
250 PRINT#3," "
260 PRINT#3," "
270 PRINT#3," "
280 PRINT#3,"   DBM     V RMS      V PEAK     V P-P ";
290 PRINT#3,"    DBM     V RMS      V PEAK     V P-P"
300 PRINT#3," "
310 FOR K = 0 TO 32
320 L = K + 33
330 PRINT#3, USING "   -## ";K;
340 PRINT#3, USING "  #.#######";VRMS(K),VP(K),VPP(K);
350 PRINT#3, USING "   -## ";L;
360 PRINT#3, USING "  #.#######";VRMS(L),VP(L),VPP(L)
370 NEXT
380 PRINT#3," "
390 PRINT#3," "
400 PRINT#3,"       CALCULATIONS MADE ASSUMING 600 OHM LOAD"
410 CLOSE
420 END

370 NEX