


                        APPENDIX C

              SINEWAVE TABLE GENERATOR PROGRAM






    10 ' This program generates a sinewave signal
    11 ' look-up table.  The results are coded into
    12 ' DATA statements so that it can be easily
    13 ' added directly into the TMS320 code.
    14 '
    15 '   Written by:  Peter Ehlig
    16 '   Copyright Texas Instruments, 07/18/86
    17 '
    30 PRINT 'PROGRAM STARTED"
    40 INPUT "ENTER NAME OF OUTPUT FILE = ",OUTFILE$
    50 OPEN OUTFILE$ FOR OUTPUT AS #3
    100 PI = 3.1415927#
    110 PI2 = PI * 2
    120 INPUT "TABLE LENGTH = ",TBLEN
    130 DELTA = PI2 / TBLEN
    140 INDX1 = -DELTA
    150 NETDEG = 360 / TBLEN
    160 PRINT#3,"***********************************************************"
    170 PRINT#3,"SINE EQU $ SINE TABLE LENGTH = ";
    180 PRINT#3, USING "###";TBLEN
    190 FOR I = 1 TO TBLEN
    200 INDX1 = INDX1 + DELTA
    210 TBL = SIN(INDX1)
    220 HTBL$ = HEX$(TBL*16384)
    230 RADS = INDX1 / PI
    240 DEGR = NETDEG * (I - 1)
    250 PRINT#3, " DATA ";
    260 PRINT#3, USING ">\ \";HTBL$;
    270 PRINT#3, " ANGLE = ";
    280 PRINT#3, USING "###.####";DEGR;
    290 PRINT#3, " SINE = ";
    300 PRINT#3, USING "#.######";TBL
    310 NEXT
    315 PRINT#3,"***********************************************************"
    320 PRINT#3, " PAGE"
    330 CLOSE
    340 PRINT "PROGRAM FINISHED"
    350 END

